﻿Imports System.Runtime.InteropServices
<ComClassAttribute(Lagerserver.ClassId, Lagerserver.InterfaceId, Lagerserver.EventsId)>
<ComVisible(True)>
Public Class Lagerserver
    Public Const ClassId = "44558DD7-87AD-433f-9B1B-C478233D6C69"
    Public Const InterfaceId = "959A6835-4768-4cd5-89BE-7D408C2B86AA"
    Public Const EventsId = "02E3954F-5DC1-4ad9-1967-354F0E82BCA3"

    Private ConnectionHolder As Object

    ''' <summary>
    ''' Datenbankverbindung aufbauen
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <ComVisible(True)>
    Public Function init() As Boolean
        Return ConnectSQL()
        'Return True
    End Function

    ''' <summary>
    ''' HEUREKA wird beim schließen versuchen die Verbindung zum ComServer zu schließen.
    ''' Aktive Verbindungen des ComServers können dadurch rechtzeitig geschlossen werden
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Close()

    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="ISBN">ISBN ohne Bindestriche</param>
    ''' <param name="EAN">EAN ohne Bindestriche</param>
    ''' <returns>XML String im vorgegebenen Format</returns>
    ''' <remarks></remarks>
    <ComVisible(True)>
    Public Function getLagerdaten(ByVal ISBN As String, ByVal EAN As String) As String
        Dim Daten As Object
        Dim strXMl As String = ""
        Daten = getDaten(ISBN, EAN)
        strXMl = getXMLString(Daten)
        Return strXMl
        'Return "<LagerDaten><ISBN/><EAN>9781111111111</EAN><Lager>1</Lager><Bestellt>1</Bestellt><Filialen><Filiale><Filialname>TestFiliale1</Filialname><Lagerbestand>1</Lagerbestand><Bestellt>1</Bestellt></Filiale><Filiale><Filialname>äöü</Filialname><Lagerbestand>1</Lagerbestand><Bestellt>1</Bestellt></Filiale></Filialen><WarengruppeWWS>12345</WarengruppeWWS><WGBezeichnungWWS>Irgendwas</WGBezeichnungWWS><PreisWWS><Preis>9,99</Preis><WKZ>€</WKZ><MWST>1</MWST></PreisWWS><Zusatzinfo><Info>Erste WWS Info</Info><Info>Zweite WWS Info</Info></Zusatzinfo></LagerDaten>"
    End Function

    ''' <summary>
    ''' Abrufen von Lagerdaten
    ''' </summary>
    ''' <param name="ISBN"></param>
    ''' <param name="EAN"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function getDaten(ByVal ISBN As String, ByVal EAN As String) As String

    End Function

    ''' <summary>
    ''' abgerufene Lagerdaten im XML-Format aufarbeitet
    ''' </summary>
    ''' <param name="Daten"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function getXMLString(ByVal Daten As Object) As String

    End Function

    ''' <summary>
    ''' Datenverbindung zum System (beispielsweise SQL Server) aufbauen
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function ConnectSQL() As Boolean
        'Verbindung aufbauen und aus Performancegründen die Verbindung speichern
        ConnectionHolder = OpenConnection()
        If ConnectionHolder.State = "connected" Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Function OpenConnection() As Object
        'Open Connection to Database
    End Function


End Class
